# frozen_string_literal: true
require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe StatesController, type: :controller do
  # This should return the minimal set of attributes required to create a valid
  # State. As you add validations to State, be sure to
  # adjust the attributes here as well.

  let(:organization) { create(:organization) }
  let(:item_type) { create(:item_type, organization: organization) }
  let(:state) { create(:state, item_type: item_type) }

  let(:invalid_attributes) do
    attributes_for(:item_type, name: nil)
  end

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # StatesController. Be sure to keep this updated too.
  let(:valid_session) do
    { user_id: { 'uid' => create(:user).uid, 'extra' => { 'is_admin' => true } } }
  end

  describe 'GET #index' do
    it 'assigns all states as @states' do
      get :index, params: { organization_id: organization.id, item_type_id: item_type.id },
                  session: valid_session
      expect(assigns(:states)).to include(state)
    end
  end

  describe 'GET #show' do
    it 'assigns the requested state as @state' do
      get :show, params: { organization_id: organization.id, item_type_id: item_type.id,
                           id: state.to_param }, session: valid_session
      expect(assigns(:state)).to eq(state)
    end
  end

  describe 'GET #new' do
    it 'assigns a new state as @state' do
      get :new, params: { organization_id: organization.id, item_type_id: item_type.id },
                session: valid_session
      expect(assigns(:state)).to be_a_new(State)
    end
  end

  describe 'GET #edit' do
    it 'assigns the requested state as @state' do
      get :edit, params: { organization_id: organization.id, item_type_id: item_type.id,
                           id: state.to_param }, session: valid_session
      expect(assigns(:state)).to eq(state)
    end
  end

  describe 'POST #create' do
    context 'with valid params' do
      it 'creates a new State' do
        item_type
        expect do
          post :create, params: { organization_id: organization.id, item_type_id: item_type.id,
                                  state: attributes_for(:state) }, session: valid_session
        end.to change(State, :count).by(1)
      end

      it 'assigns a newly created state as @state' do
        post :create, params: { organization_id: organization.id, item_type_id: item_type.id,
                                state: attributes_for(:state) }, session: valid_session
        expect(assigns(:state)).to be_a(State)
        expect(assigns(:state)).to be_persisted
      end

      it 'redirects to the created state' do
        post :create, params: { organization_id: organization.id, item_type_id: item_type.id,
                                state: attributes_for(:state) }, session: valid_session
        expect(response).to redirect_to([organization, item_type, State.last])
      end
    end

    context 'with invalid params' do
      it 'assigns a newly created but unsaved state as @state' do
        post :create, params: { organization_id: organization.id, item_type_id: item_type.id,
                                state: invalid_attributes }, session: valid_session
        expect(assigns(:state)).to be_a_new(State)
      end

      it "re-renders the 'new' template" do
        post :create, params: { organization_id: organization.id, item_type_id: item_type.id,
                                state: invalid_attributes }, session: valid_session
        expect(response).to render_template('new')
      end
    end
  end

  describe 'PUT #update' do
    context 'with valid params' do
      let(:new_attributes) do
        attributes_for(:state)
      end

      it 'updates the requested state' do
        put :update, params: { organization_id: organization.id,
                               item_type_id: item_type.id, id: state.to_param,
                               state: new_attributes },
                     session: valid_session
        state.reload
        expect(state.name).to eq(new_attributes[:name])
      end

      it 'assigns the requested state as @state' do
        put :update, params: { organization_id: organization.id, item_type_id: item_type.id,
                               id: state.to_param, state: attributes_for(:state) },
                     session: valid_session
        expect(assigns(:state)).to eq(state)
      end

      it 'redirects to the state' do
        put :update, params: { organization_id: organization.id, item_type_id: item_type.id,
                               id: state.to_param, state: attributes_for(:state) },
                     session: valid_session
        expect(response).to redirect_to([organization, item_type, state])
      end
    end

    context 'with invalid params' do
      it 'assigns the state as @state' do
        put :update, params: { organization_id: organization.id, item_type_id: item_type.id,
                               id: state.to_param, state: invalid_attributes },
                     session: valid_session
        expect(assigns(:state)).to eq(state)
      end

      it "re-renders the 'edit' template" do
        put :update, params: { organization_id: organization.id, item_type_id: item_type.id,
                               id: state.to_param, state: invalid_attributes },
                     session: valid_session
        expect(response).to render_template('edit')
      end
    end
  end

  describe 'DELETE #destroy' do
    before(:each) { create(:state, item_type: item_type) }

    it 'destroys the requested state' do
      expect do
        delete :destroy, params: { organization_id: organization.id, item_type_id: item_type.id,
                                   id: State.last.to_param }, session: valid_session
      end.to change(State, :count).by(-1)
    end

    it 'redirects to the states list' do
      delete :destroy, params: { organization_id: organization.id, item_type_id: item_type.id,
                                 id: State.last.to_param }, session: valid_session
      expect(response).to redirect_to([organization, item_type, :states])
    end
  end

  describe 'GET #graph_map' do
    render_views

    let(:json) { JSON.parse(response.body) }
    let(:state1) { create(:state, item_type: item_type) }
    let(:state2) { create(:state, item_type: item_type, reachable_states: [state1]) }

    subject { json }

    before do
      item_type
      State.delete_all
      state1 && state2
      get :graph_map, params: { organization_id: organization.id, item_type_id: item_type.id },
                      format: :json
    end

    it { is_expected.to include('edges') }
    it { is_expected.to include('nodes') }
    it { expect(json['edges']).to be_kind_of(Array) }
    it { expect(json['edges'].count).to eq(1) }
    it { expect(json['nodes']).to be_kind_of(Array) }
    it { expect(json['nodes'].count).to eq(2) }

    describe 'edge' do
      subject { json['edges'].first }

      it { is_expected.to include('id') }
      it { expect(subject['id']).to eq(state2.to_param + state1.to_param) }
      it { is_expected.to include('source') }
      it { expect(subject['source']).to eq(state2.to_param) }
      it { is_expected.to include('target') }
      it { expect(subject['target']).to eq(state1.to_param) }
    end

    describe 'node' do
      subject { json['nodes'].first }

      it { is_expected.to include('id') }
      it { expect(subject['id']).to eq(state1.to_param) }
      it { is_expected.to include('label') }
      it { expect(subject['label']).to eq(state1.name) }
      it { is_expected.to include('color') }
      it { expect(subject['color']).to eq('#' + state1.color) }
      it { is_expected.to include('size') }
    end
  end
end
